package fitNesseFixture;

import java.util.ArrayList;

import exceptions.CategoryInvalidException;
import exceptions.DescriptionInvalidException;
import exceptions.ImageInvalidException;
import exceptions.TitleInvalidException;
import project.Category;
import project.Item;
import project.ItemPicture;

public class ItemFixture {

	private Item i;
	private String title, description, category;
	private ArrayList<ItemPicture> images = new ArrayList<ItemPicture>();
	Category c;

	public ItemFixture(String cat) {

		c = new Category(cat);

	}

	public ItemFixture(int[] imagesToCreate) {

		for (int i : imagesToCreate) {

			ItemPicture ip = new ItemPicture();

			ip.setId(i);
			images.add(ip);

		}

	}

	public String modify() {

		i = Item.getInstance();

		try {

			if (i.modify(title, description, category)) {

				return "Item modified!";

			}

		} catch (TitleInvalidException e) {

			return e.getMessage();

		} catch (DescriptionInvalidException e) {

			return e.getMessage();

		} catch (CategoryInvalidException e) {

			return e.getMessage();

		}

		return null;

	}

	public String addPicture() {

		i = Item.getInstance();

		try {

			if (i.addPicture(images)) {

				return "Pictures added!";

			}

		} catch (ImageInvalidException e) {

			return e.getMessage();

		}

		return null;

	}

	public void setImages(int[] imgs) {

		for (int i : imgs) {

			ItemPicture ip = new ItemPicture();

			ip.setId(i);
			images.add(ip);

		}

	}

	public void setCategory(String category) {

		this.category = category;

	}

	public void setTitle(String title) {

		this.title = title;

	}

	public void setI(Item i) {

		this.i = i;

	}

	public void setDescription(String description) {

		this.description = description;

	}

}
