package fitNesseFixture;

import exceptions.CategoryInvalidException;
import exceptions.DateInvalidException;
import exceptions.DescriptionInvalidException;
import exceptions.ImageInvalidException;
import exceptions.ItemNonExistentException;
import exceptions.PriceInvalidException;
import exceptions.TitleInvalidException;
import project.Category;
import project.Item;
import project.ItemPicture;
import project.Seller;

public class SellerFixture {

	private Seller s;
	private String title, description, startTime, endTime, category;
	private int[] images;

	private int item;
	private double price, bidIncrement;

	Category c;

	public SellerFixture(int itemIDInput) {

		Item i = new Item();
		i.setId(itemIDInput);

	}

	public SellerFixture(int[] imagesToCreate, String cat) {

		for (int i : imagesToCreate) {

			ItemPicture pic = new ItemPicture();
			pic.setId(i);

		}

		c = new Category(cat);

	}

	public String createAuction() {

		s = Seller.getInstance();

		try {

			if (s.createAuction(Item.getItem(item), startTime, endTime, price, bidIncrement)) {

				return "Auction created!";

			}

		} catch (PriceInvalidException e) {

			return e.getMessage();

		} catch (DateInvalidException e) {

			return e.getMessage();

		} catch (ItemNonExistentException e) {

			return e.getMessage();
		}

		return null;

	}

	public String createItem() {

		s = Seller.getInstance();

		try {

			if (s.createItem(title, description, images, category)) {

				return "Item created!";

			}

		} catch (CategoryInvalidException e) {

			return e.getMessage();

		} catch (TitleInvalidException e) {

			return e.getMessage();

		} catch (DescriptionInvalidException e) {

			return e.getMessage();

		} catch (ImageInvalidException e) {

			return e.getMessage();

		}

		return null;
	}

	public void setImages(int[] images) {

		this.images = images;

	}

	public void setStartTime(String startTime) {

		this.startTime = startTime;

	}

	public void setEndTime(String endTime) {

		this.endTime = endTime;

	}

	public void setItem(int item) {

		this.item = item;

	}

	public void setPrice(double price) {

		this.price = price;

	}

	public void setBidIncrement(double bidIncrement) {

		this.bidIncrement = bidIncrement;

	}

	public void setTitle(String title) {

		this.title = title;

	}

	public void setDescription(String description) {

		this.description = description;

	}

	public void setCategory(String category) {
		this.category = category;
	}

}
